/*
 * SWE-Praktikum: Freiburg
 * 
 * Letztes Aenderungsdatum: $Date: 2016-01-08 14:33:46 +0100 (Fr, 08 Jan 2016) $
 * Letzte  Revision:        $Revision: 1598 $
 * Zuletzt geaendert von:   $Author: stvaklei $
 * 
 */


#include <cstdlib>
#include <string>
#include <iostream>
#include <ctime>
#include <vector>
#include <ios>
#include <cmath>
#include "Finanzen.h"

#ifndef FIRMA_H
#define FIRMA_H

class Firma {
public:
    Firma();
    Firma(string name, vector<Finanzen> f);
    Firma(const Firma& obj);
    virtual ~Firma();
    void setAttr(string name, vector<Finanzen> f);


    vector<Finanzen> getFinanzen();

    bool getLinReg(int i);
    int64_t lineareRegUmsatz(int jahr);
    int64_t  lineareRegGewinn(int jahr);
    void setVorhersage();
    int64_t lineareRegBilanz(int jahr);
    int64_t lineareRegEK(int jahr);
    string getName();
    int64_t getUmsatz(int i);
    int64_t getGewinn(int i);
    int64_t getBilanzsumme(int i);
    int64_t getEigenkapital(int i);
    double getEKAnteil(int i);
    double getUmsatzrendite(int i);
    tm getDatum(int i);

    int getAnzahlTage();
    double getCAGRUmsatz(int i);
    double getCAGRGewinn(int i);
    int getXStrich();
    void setMGewinn();
    void setBGewinn(double xSt, int64_t ySt);
    void setMUmsatz();
    void setBUmsatz(double xSt, int64_t ySt);
    void setMBilanzsumme();
    void setBBilanzsumme(double xSt, int64_t ySt);
    void setMEigenkapital();
    void setBEigenkapital(double xSt, int64_t ySt);


private:
    void setCAGRUmsatz();
    void setCAGRGewinn();
       
    vector<double> cagru;
    vector<double> cagrg;
    vector<Finanzen> daten;

    
    int64_t mGewinnl;
    int64_t mUmsatzl ;
    int64_t mBilnazsummel;
    int64_t mEigenkapitall; //m=Steigung Lin Reg
    int64_t bGewinnl;
    int64_t bUmsatzl ;
    int64_t bBilanzsummel ;
    int64_t bEigenkapital ; //b=y-Achsenabschnitt LinReg
    

//    string prozent(double i);

    string name = "LEER()";
};

#endif /* FIRMA_H */

