/*
 * SWE-Praktikum: Freiburg
 * 
 * Letztes Aenderungsdatum: $Date: 2016-01-09 17:22:41 +0100 (Sa, 09 Jan 2016) $
 * Letzte  Revision:        $Revision: 1659 $
 * Zuletzt geaendert von:   $Author: stvaklei $
 * 
 */


#include "MenueSystem.h"

struct vergleich_int
{   inline bool operator() (const Wert struct1, const Wert struct2)
    {   return (struct1.iw < struct2.iw);    }
};
struct vergleich_double
{   inline bool operator() (const Wert struct1, const Wert struct2)
    {   return (struct1.dw < struct2.dw);    }
};
struct vergleich_string
{   inline bool operator() (const Wert struct1, const Wert struct2)
    {   return (struct1.stw < struct2.stw);    }
};

MenueSystem *MenueSystem::instanz =0;
//Singelton
MenueSystem* MenueSystem::gibMenue(){
if(instanz==NULL){
instanz= new MenueSystem();
//cout<<"singelton ---------------------------------------------__"<<endl;
return instanz;
}
else{
//cout<<"singelton ----else-----------------------------------------__"<<endl;
return instanz;
}
}

MenueSystem::MenueSystem() {
}


MenueSystem::~MenueSystem() {
}

MenueSystem::MenueSystem(vector<Firma> firmen, int jahre) {
    setAttr(firmen, jahre);
}

void MenueSystem::setAttr(vector<Firma> firmen, int jahre) {
    this->firmen = firmen;
    this->elemente = jahre;
}


string MenueSystem::datumString(tm date) {
    string a;
    a = pad(to_string(date.tm_year + 1900) + "-", '0', 5);
    a += pad(to_string(date.tm_mon + 1) + "-", '0', 3);
    a += pad(to_string(date.tm_mday), '0', 2);
    return a;

}

void MenueSystem::displaySpalten() {
    
   
    // Stellt alle aktuellen Spalten des Menuesystems dar
    
    cout << endl;
    
    // Auto-Save
    
    saveState();
    
    // Titelzeile 
    
    for (int i = 0; i < spalten.size(); i++) {
        cout << setw(getLength(spalten[i]) + 2);
        cout << right;
        cout << spalten[i].titel;
    }

    cout << fixed;
    cout << setprecision(3);
    cout << endl;
    
    int laenge;
    int j;
    for (int k = 0; k < anzahlEintraege; k++) {
        for (int i = 0; i < spalten.size(); i++) {
            j = reihenfolge[k];
            laenge = getLength(spalten[i]) + 2;
            cout << setw(laenge);
            cout << right;
    // Es gibt drei Wertetypen in der Tabelle
            switch (spalten[i].type) {
                case StringSpalte: {
                    cout << spalten[i].werte[j].stw;
                    break;
                }
                case IntSpalte: {
                    int64_t tmp = spalten[i].werte[j].iw; // Int umrechnungsfaktor fuer waehrung
                    string p;
                    if (spalten[i].werte[j].linReg)
                        p = "*";
                    if (tmp < 0) { 
                        tmp *= -1;
                        p += "(" + intStr(tmp) + ")";
                        cout << p;
                    } else {
                        p += intStr(tmp);
                        cout << p;
                    }
                    break;
                }
                case DoubleSpalte: {

                    // Bei CAGR werden die fehlenden Elemente nicht populiert
                    if (j >=  spalten[i].werte.size()) {
                        cout << " ";
                        break;
                    }
                     
                    ostringstream p; 
                    if (spalten[i].werte[j].linReg)
                        p << "*";
                    
                    double tmp = spalten[i].werte[j].dw;
                    if (tmp < 0.0) { 
                        tmp *= -1.0;
                        p << "(" << setprecision(3) << fixed;
                        p << tmp * 100.0 << "%)";
                        cout << p.str();
                    } else {
                        p << setprecision(3) << fixed;
                        p << tmp * 100.0 << "%"; 
                        cout << p.str();
                       // cout << setw(laenge);
                    }
                }
            }
        }
        cout << endl;
    }
    
    cout << endl;    
    cout << "Sortiert nach Spalte: [" << spalten[sortSpalte].titel << "] (";
    if (aufsteigend) {
        cout << "aufsteigend)" << endl;
    } else {
        cout << "absteigend)" << endl;
    }
    cout << endl;

}

/*
    void neueSpalte(int findex);
    void buildFirmenSpalten();
    void buildDatenSpalten();*/

void MenueSystem::buildFirmenSpalten() {
// baut den vektor mit moeglichen Spalten fuer die Firmentabelle auf
    Spalte a;
    Wert t;
    
    setloc(); // Locale setzen
    
    hiddenSpalten.clear();

    ////////////

    a.type = StringSpalte;
    a.titel = "Name";
    for (int i = 0; i < firmen.size(); i++) {
        t.stw = firmen[i].getName();
        t.index = i;
        a.werte.push_back(t);
    }
    hiddenSpalten.push_back(a);

    ////////////

    a.type = StringSpalte;
    a.titel = "Letzter Report";
    a.werte.clear();
    for (int i = 0; i < firmen.size(); i++) {
        t.stw = datumString(firmen[i].getFinanzen()[0].getDatum());
        t.index = i;
        a.werte.push_back(t);
    }
    hiddenSpalten.push_back(a);

    ////////////

    a.type = IntSpalte;
    a.titel = "Letzter Umsatz [" + waehrung_ISO[waehrung] + "]";
    a.werte.clear();
    for (int i = 0; i < firmen.size(); i++) {
        t.iw = firmen[i].getUmsatz(0) * firmen[i].getFinanzen()[0].getKonv(waehrung);
        t.index = i;
        a.werte.push_back(t);
    }
    hiddenSpalten.push_back(a);

    ////////////

    a.type = IntSpalte;
    a.titel = "Letzter Gewinn [" + waehrung_ISO[waehrung] + "]";
    a.werte.clear();
    for (int i = 0; i < firmen.size(); i++) {
        t.iw = firmen[i].getGewinn(0) * firmen[i].getFinanzen()[0].getKonv(waehrung);
        t.index = i;
        a.werte.push_back(t);
    }
    hiddenSpalten.push_back(a);

    ////////////

    a.type = IntSpalte;
    a.titel = "Letzte Bilanzsumme [" + waehrung_ISO[waehrung] + "]";
    a.werte.clear();
    for (int i = 0; i < firmen.size(); i++) {
        t.iw = firmen[i].getBilanzsumme(0) * firmen[i].getFinanzen()[0].getKonv(waehrung);
        t.index = i;
        a.werte.push_back(t);
    }
    hiddenSpalten.push_back(a);

    ////////////

    a.type = IntSpalte;
    a.titel = "Letztes Eigenkapital [" + waehrung_ISO[waehrung] + "]";
    a.werte.clear();
    for (int i = 0; i < firmen.size(); i++) {
        t.iw = firmen[i].getEigenkapital(0) * firmen[i].getFinanzen()[0].getKonv(waehrung);
        t.index = i;
        a.werte.push_back(t);
    }
    hiddenSpalten.push_back(a);

    ////////////

    a.type = DoubleSpalte;
    a.titel = "Letzte CAGR (Umsatz)";
    a.werte.clear();
    for (int i = 0; i < firmen.size(); i++) {
        t.dw = firmen[i].getCAGRUmsatz(0);
        t.index = i;
        a.werte.push_back(t);
    }
  //  reverse(a.werte.begin(), a.werte.end()); // CAGR sind verkehrt herum
    hiddenSpalten.push_back(a);

    ////////////

    a.type = DoubleSpalte;
    a.titel = "Letzte CAGR (Gewinn)";
    a.werte.clear();
    for (int i = 0; i < firmen.size(); i++) {
        t.dw = firmen[i].getCAGRGewinn(0);
        t.index = i;
        a.werte.push_back(t);
    }
  //  reverse(a.werte.begin(), a.werte.end()); // CAGR sind verkehrt herum
    hiddenSpalten.push_back(a);

    ////////////

    a.type = DoubleSpalte;
    a.titel = "Letzter EK-Anteil";
    a.werte.clear();
    for (int i = 0; i < firmen.size(); i++) {
        t.dw = firmen[i].getEKAnteil(0);
        t.index = i;
        a.werte.push_back(t);
    }
    hiddenSpalten.push_back(a);

    ////////////

    a.type = DoubleSpalte;
    a.titel = "Letzte Umsatzrendite";
    a.werte.clear();
    for (int i = 0; i < firmen.size(); i++) {
        t.dw = firmen[i].getUmsatzrendite(0);
        t.index = i;
        a.werte.push_back(t);
    }
    hiddenSpalten.push_back(a);


}


void MenueSystem::buildDatenSpalten() {
// baut den vektor mit moeglichen Spalten fuer die Datentabelle auf
    Firma f = firmen[findex];
    Spalte a;
    Wert t;
    
    setloc(); // Locale setzen
    neueVorhersage();
    
    hiddenSpalten.clear();
    
    ////////////

    a.type = StringSpalte;
    a.titel = "Datum";
    a.werte.clear();
    for (int i = 0; i < anzahlEintraege; i++) {
        t.stw = datumString(f.getDatum(i));
        t.index = i;
        a.werte.push_back(t);
    }
    hiddenSpalten.push_back(a);
    
    ////////////

    a.type = IntSpalte;
    a.titel = "Umsatz [" + waehrung_ISO[waehrung] + "]";
    a.werte.clear();
    for (int i = 0; i < anzahlEintraege; i++) {
        t.iw = f.getUmsatz(i) * firmen[i].getFinanzen()[i].getKonv(waehrung);
        t.index = i;
        t.linReg = f.getLinReg(i);
        a.werte.push_back(t);
    }
    hiddenSpalten.push_back(a);

    ////////////

    a.type = IntSpalte;
    a.titel = "Gewinn [" + waehrung_ISO[waehrung] + "]";
    a.werte.clear();
    for (int i = 0; i < anzahlEintraege; i++) {
        t.iw = f.getGewinn(i) * firmen[i].getFinanzen()[i].getKonv(waehrung);
        t.index = i;
        t.linReg = f.getLinReg(i);
        a.werte.push_back(t);
    }
    hiddenSpalten.push_back(a);

    ////////////

    a.type = IntSpalte;
    a.titel = "Bilanzsumme [" + waehrung_ISO[waehrung] + "]";
    a.werte.clear();
    for (int i = 0; i < anzahlEintraege; i++) {
        t.iw = f.getBilanzsumme(i) * firmen[i].getFinanzen()[i].getKonv(waehrung);
        t.index = i;
        t.linReg = f.getLinReg(i);
        a.werte.push_back(t);
    }
    hiddenSpalten.push_back(a);

    ////////////

    a.type = IntSpalte;
    a.titel = "Eigenkapital [" + waehrung_ISO[waehrung] + "]";
    a.werte.clear();
    for (int i = 0; i < anzahlEintraege; i++) {
        t.iw = f.getEigenkapital(i) * firmen[i].getFinanzen()[i].getKonv(waehrung);
        t.index = i;
        t.linReg = f.getLinReg(i);
        a.werte.push_back(t);
    }
    hiddenSpalten.push_back(a);

    ////////////
    // CAGR geht ja nur fuer maximal 2 Eintraege !!
    a.type = DoubleSpalte;
    a.titel = "CAGR (Umsatz)";
    a.werte.clear();
    for (int i = 0; i < anzahlEintraege - 3; i++) {
        t.dw = f.getCAGRUmsatz(i);
        t.index = i;
        t.linReg = f.getLinReg(i);
        a.werte.push_back(t);
    }
    hiddenSpalten.push_back(a);

    ////////////

    a.type = DoubleSpalte;
    a.titel = "CAGR (Gewinn)";
    a.werte.clear();
    for (int i = 0; i < anzahlEintraege -3; i++) {
        t.dw = f.getCAGRGewinn(i);
        t.index = i;
        t.linReg = f.getLinReg(i);
        a.werte.push_back(t);
    }
    hiddenSpalten.push_back(a);

    ////////////

    a.type = DoubleSpalte;
    a.titel = "EK-Anteil";
    a.werte.clear();
    for (int i = 0; i < anzahlEintraege; i++) {
        t.dw = f.getEKAnteil(i);
        t.index = i;
        t.linReg = f.getLinReg(i);
        a.werte.push_back(t);
    }
    hiddenSpalten.push_back(a);

    ////////////

    a.type = DoubleSpalte;
    a.titel = "Umsatzrendite";
    a.werte.clear();
    for (int i = 0; i < anzahlEintraege; i++) {
        t.dw = f.getUmsatzrendite(i);
        t.index = i;
        t.linReg = f.getLinReg(i);
        a.werte.push_back(t);
    }
    hiddenSpalten.push_back(a);


}



void MenueSystem::rebuildFirmen() {
    // Initialisieren der Firmentabelle
    Spalte a;
    buildFirmenSpalten();
    a = hiddenSpalten[0];
    spalten.clear();
    spalten.push_back(a);
    benutzteSpalten.clear();
    benutzteSpalten.push_back(0);
    aufsteigend = true;
    sortSpalte = 0;
    sortieren(a);
    anzahlEintraege = firmen.size();
    cout << endl;
}

void MenueSystem::tableFirmen() {

    rebuildFirmen();
    while (firmenMenue() != "q") {}
}

string MenueSystem::firmenMenue() {
    // Rueckgabewert ist die letzte User-Eingabe.
    findex = 0;
    string input = "";
    while (input != "q") {
        aktMenue = Auswahl;
        displaySpalten();
        cout << "Auswahl:" << endl << endl;
        cout << "n - Neue Spalte anhaengen" << endl;
        cout << "l - Spalte loeschen" << endl;
        cout << "i - Spalte an beliebiger Stelle einfuegen" << endl;
        cout << "s - Sortieren" << endl;
        cout << "f - Firmendaten abrufen" << endl;
        cout << "w - Waehrung/Darstellung aendern (Aktuell " << waehrung_ISO[waehrung] << ")" << endl;
        cout << "q - Beenden" << endl;
        cout << endl << endl;
        cin >> input;
        switch (input[0]) {
            case 'n':
            {
                neueSpalte();
                break;
            }
            case 'l':
            {
                deleteSpalte();
                break;
            }
            case 'i':
            {
                insertSpalte();
                break;
            }
            case 's':
            {
                sortSpalten();
                break;
            }
            case 'f':
            {
                input =  promptFirma();
                rebuildFirmen();
                break;
            }
            case 'w':
            {
                setWaehrung();
                spalten.clear();
                buildFirmenSpalten();   
                for (int i = 0; i < benutzteSpalten.size(); i++)
                    spalten.push_back(hiddenSpalten[benutzteSpalten[i]]);
                sortieren(spalten[sortSpalte]);   
                break;
            }
            case 'q':
            {
                return input;
                break;
            }
        }
        
    }
    // Alles zuruecksetzen

    Spalte a;
    buildFirmenSpalten();
    a = hiddenSpalten[0];
    spalten.clear();
    spalten.push_back(a);    
    benutzteSpalten.clear();
    benutzteSpalten.push_back(0);
    aufsteigend = true;
    sortSpalte = 0;
    sortieren(a);
    anzahlEintraege = firmen.size();
    cout << endl;
    
    return input;
}

string MenueSystem::promptFirma() {
    
    cout << endl;
    // Alle Firmen anzeigen
    for (int i = 0; i < firmen.size(); i++) {
        cout << i+1 << ") " << firmen[i].getName() << endl;
    }
    cout << endl << "Auswahl: ";
    int input;
    cin >> input;
    
    cout << input << endl;
    printf("input == %d\n", input);
    printf("firmen.size() == %u\n", firmen.size());
    if ((input > 0) && (input <= firmen.size())) {
        cout << ":DASJFJDFGSDJG";
  //      cout << endl << "Auswahl - " << firmen[input-1].getName() << endl;
        cout << input;
        findex = input-1;
        return tableDaten();
    }
    
}

int MenueSystem::inputInt() {
    cout << endl << "Auswahl: ";
    int input;
    cin >> input;
    return input;            
}

void MenueSystem::neueSpalte() {

    cout << endl;
    cout << "Neue Spalte anhaengen:";
    cout << endl;
    
    for (int i = 0; i < hiddenSpalten.size(); i++) {
        cout << i+1 << ") " << hiddenSpalten[i].titel << endl;
    }
    
    int input = inputInt();
    
    if ((input > 0) && (input <= hiddenSpalten.size())) {
        spalten.push_back(hiddenSpalten[input-1]);
        benutzteSpalten.push_back(input-1);
    }

}

void MenueSystem::deleteSpalte() {
    
    if (spalten.size() == 0) {
        cout << endl << "Es gibt keine Spalten zum loeschen!" << endl;
        return;
    }
    
    cout << endl;
    cout << "Spalte loeschen:";
    cout << endl;
    
    for (int i = 0; i < spalten.size(); i++) {
        cout << i+1 << ") " << spalten[i].titel << endl;
    }
    
    int input = inputInt();
    
    if ((input > 0) && (input <= spalten.size())) {
        spalten.erase(spalten.begin() + input - 1);
        benutzteSpalten.erase(benutzteSpalten.begin() + input - 1);
    }

}

void MenueSystem::insertSpalte() {

    cout << endl;
    cout << "Neue Spalte einfuegen:";
    cout << endl;
    
    for (int i = 0; i < hiddenSpalten.size(); i++) {
        cout << i+1 << ") " << hiddenSpalten[i].titel << endl;
    }
    
    int input = inputInt();
    
    if ((input <= 0) || (input > hiddenSpalten.size())) {
        return;              
    }
    
    cout << endl << input << endl;
        
    cout << endl << "Vor welcher Stelle soll die Spalte eingefuegt werden?" << endl;
    
    for (int i = 0; i < spalten.size(); i++) {
        cout << i+1 << ") " << spalten[i].titel << endl;
    }
            
    int stelle = inputInt();
    
    if ((input > 0) && (input <= hiddenSpalten.size())) {
        spalten.insert(spalten.begin() + stelle - 1, hiddenSpalten[input-1]);
        benutzteSpalten.insert(benutzteSpalten.begin() + stelle - 1, input-1);
    }

}


void MenueSystem::sortSpalten() {
    
    cout << endl;
    cout << "Sortieren nach Spalte:";
    cout << endl;
    
    for (int i = 0; i < spalten.size(); i++) {
        cout << i+1 << ") " << spalten[i].titel << endl;
    }
    
    int input = inputInt();
    
    if ((input > 0) && (input <= spalten.size())) {
        string rf;
        cout << endl << "Aufsteigend(j/n)? ";
        while ((rf != "j") && (rf != "n")) {
            cin >> rf;
        }
        Spalte tmp = spalten[input-1];
        sortSpalte = input-1;
        
        if (rf == "j") {
            aufsteigend = true;
        } else {            
            aufsteigend = false;
        }
        sortieren(tmp);
        
    }
}

string MenueSystem::tableDaten() {
    // Rueckgabewert ist die letzte User-Eingabe
    
    Firma p = firmen[findex];
    spalten.clear();
    
    anzahlEintraege = elemente;
    
    buildDatenSpalten();   
    
    spalten.push_back(hiddenSpalten[0]);
    benutzteSpalten.clear();
    benutzteSpalten.push_back(0);
    
    aufsteigend = true;
    sortSpalte = 0;
    sortieren(spalten[0]);
    
    cout << endl;
    return datenMenue(p);
}

string MenueSystem::datenMenue(Firma p) {
    string input = "";

    while ((input != "q") && (input != "f")) {
        aktMenue = Daten;
        cout << "Firma: " << p.getName() << endl << endl;
        cout << "Tage bis zum naechsten Report: " << p.getAnzahlTage() << endl;
        displaySpalten();
        cout << "    * = Werte basieren auf linearer Regression" << endl;
        cout << endl;
        cout << "Auswahl:" << endl << endl;
        cout << "n - Neue Spalte anhaengen" << endl;
        cout << "l - Spalte loeschen" << endl;
        cout << "i - Spalte an beliebiger Stelle einfuegen" << endl;
        cout << "s - Sortieren" << endl;
        cout << "f - Zurueck zum Firmen-Menue" << endl;
        cout << "w - Waehrung/Darstellung aendern (Aktuell " << waehrung_ISO[waehrung] << ")" << endl;
        cout << "q - Beenden" << endl;
        cout << endl << endl;
        cin >> input;
        switch (input[0]) {
            case 'n': {
                neueSpalte();
                break;
            }
            case 'l': {
                deleteSpalte();
                break;
            }
            case 'i': {
                insertSpalte();
                break;
            }
            case 's': {
                sortSpalten();
                break;
            }
            case 'f': {
                cleanFirma();
                return input;
                break;
            }
            case 'w':
            {
                setWaehrung();
                spalten.clear();
                buildDatenSpalten();   
                for (int i = 0; i < benutzteSpalten.size(); i++)
                    spalten.push_back(hiddenSpalten[benutzteSpalten[i]]);
                sortieren(spalten[sortSpalte]);                
                break;
            }
            case 'q': {
                return input;
                break;
            }
        }        
    }
  

}

void MenueSystem::cleanFirma() {
    //Loescht alle berechneten Werte aus dem Finanzvektor
    Firma p = firmen[findex];
    vector<Finanzen> f = p.getFinanzen();
    vector<Finanzen> tmp;
    for (int i = 0; i < f.size(); i++) {
        if (!f[i].getVorhersage()) {
            tmp.push_back(f[i]);
        }
    }
    
    firmen[findex].setAttr(p.getName(), tmp);
    
}

void MenueSystem::neueVorhersage() {
    
    vorhersagen++;
    firmen[findex].setVorhersage();
    anzahlEintraege++;
}

void MenueSystem::start() {
    // Startet das Menue
    cout << "Suche Speicherstand" << endl;
    
    bool exists = ( access( "save.dat", F_OK ) != -1 );
    if (exists) {
        cout << "Ein Speicherstand existiert. Moechten Sie ihn laden (j/n)? ";
        string input;
        cin >> input;
        if (input == "j") {
            loadState();
        } else {
            tableFirmen();
        }   
    } else {
        tableFirmen();
    }
}

int MenueSystem::getLength(Spalte a) {
    // Gibt die benötigte Länge einer Spalte zurück fuer Stringgenerierung
    int length = a.titel.length();
    int tmp = 0;
    for (int i = 0; i < a.werte.size(); i++) {
        switch(a.type) {

            case StringSpalte: {
                // string
                tmp = a.werte[i].stw.length();
                break;
            }
            case IntSpalte: {
                //int64_t
                tmp = intStr(a.werte[i].iw).length();
                if (a.werte[i].iw < 0) tmp +=1;         
                // Das minuszeichen entfaellt, dafuer kommen zwei Klammern
                break;
            }
            case DoubleSpalte: {
                //double
                ostringstream p;
                p << setprecision(3) << fixed << a.werte[i].dw << "%";
                tmp = p.str().length();
                if (a.werte[i].dw < 0.0) tmp +=1;
                // Das minuszeichen entfaellt, dafuer kommen zwei Klammern
                break;
            }


        };
        if (tmp > length) length = tmp;
    }
    return length+3;
}

string MenueSystem::pad(string a, char b, int c) {
    a.insert(0, c - a.size(), b);
    return a;
}

string MenueSystem::prozent(double i) {
// Generiert String mit Prozent. Hilfsfunktion derzeit unbenutzt !
        double tm = i * 100.0;
        tm = tm*1000.0;
        tm = rint(tm);
        tm = tm/1000.0;
        ostringstream sstream;
        sstream << tm;
        return sstream.str() + "%";

}

void MenueSystem::buildReihenfolge(Spalte s) {
    // Damit wir nach dem Sort wissen, welche Zeilen wo stehen muessen
    reihenfolge.clear();
    for (int i = 0; i < s.werte.size(); i++) {
        reihenfolge.push_back(s.werte[i].index);
    }
    
    if (s.werte.size() < anzahlEintraege) {
        for (int i = s.werte.size(); i < anzahlEintraege; i++) {
            reihenfolge.push_back(i);
        }
    }
}

void MenueSystem::sortieren(Spalte tmp) {
    // Da Wert drei Typen annehmen kann, drei verschiedene Sort-Zeilen
    switch (tmp.type) {
        case StringSpalte:
        {
            sort(tmp.werte.begin(), tmp.werte.end(), vergleich_string());
            break;
        }
        case IntSpalte:
        {
            sort(tmp.werte.begin(), tmp.werte.end(), vergleich_int());
            break;
        }
        case DoubleSpalte:
        {
            sort(tmp.werte.begin(), tmp.werte.end(), vergleich_double());
            break;
        }
    }

    buildReihenfolge(tmp);

    // Reihenfolge beachten...
    if (!aufsteigend)
        reverse(reihenfolge.begin(), reihenfolge.end());
    
}


string MenueSystem::intStr(int64_t i)  {
// Hilfsfunktion, da locale fuer int64_t nicht funktioniert
    string p, t;
    //dp="0";
    while (i >= 1000) {
        t = to_string(i % 1000);
        t.insert(0, 3 - t.size(), '0');
        p = trenn[waehrung] + t + p;
        i /= 1000;
    }
    p = to_string(i) + p;
    return p;
}

void MenueSystem::saveState() {
    // Auto-Save Datei wird bei jeder Tabellen-Aktion ausgefuehrt. 
    ofstream q ("save.dat", ios::out);
    q << aktMenue << endl;          // Welches menue
    q << findex << endl;            // Aktuelle Firma (wenn vorhanden)
    q << elemente << endl;          // Elemente in Tabelle
    q << anzahlEintraege << endl;   // Eintraege pro Firma
    
    // Abspeichern der benutzten Spalten-IDs
    q << benutzteSpalten.size() << endl;              
    for (int i = 0; i < benutzteSpalten.size(); i++)
        q << benutzteSpalten[i] << endl;
    
    // Speichern der Sortrelevanten Variablen
    q << sortSpalte << endl;
    q << aufsteigend << endl;
    q.close();
    
    saveHtml();
}

void MenueSystem::loadState() {
    ifstream q ("save.dat", ios::in);
    q >> aktMenue;
    q >> findex;
    q >> elemente;
    q >> anzahlEintraege;
    int tmpsize;
    q >> tmpsize;
    int tmp;
//    reihenfolge.clear();
    benutzteSpalten.clear();
    for (int i = 0; i < tmpsize; i++) {
        q >> tmp;
        benutzteSpalten.push_back(tmp);
    }
    q >> sortSpalte;
    q >> aufsteigend;
    q.close();
    
    // Wir entscheiden welches der beiden Menues geladen wird. 
    // Fuer beide werden jeweils initialisierende Schritte unternommen.
    if (aktMenue == Auswahl) {    
        buildFirmenSpalten();
        for (int i = 0; i < benutzteSpalten.size(); i++) {
            spalten.push_back(hiddenSpalten[benutzteSpalten[i]]);
        }
        sortieren(spalten[sortSpalte]);
        cout << endl; 
        while (firmenMenue() != "q") {}
    } else if (aktMenue == Daten) {
        Firma p = firmen[findex];
        
        anzahlEintraege = elemente;
        
        spalten.clear();
        buildDatenSpalten();   
        for (int i = 0; i < benutzteSpalten.size(); i++)
            spalten.push_back(hiddenSpalten[benutzteSpalten[i]]);
        sortieren(spalten[sortSpalte]);
                
        
        cout << endl;
        string q = datenMenue(p);
        if (q == "f") {
            tableFirmen(); // Ganz von vorne beginnen.
        }
        
    }
            
    
}

void MenueSystem::saveHtml(){
    vector<string> titel;
    for(size_t i = 0; i < spalten.size(); i++){
        titel.push_back(spalten[i].titel);
    }
    
    std::cout << "Tabelle test";
    ofstream r ("tabelle.html", ios::out);
    r << "<html>" << endl;                                                          
        r << "<head>" << endl;                                                      //header
            r << "<title>" << endl;                                                 //*
                r << "Freiburg, gebaut am #BUILD_DATE, SVN #SVN_REV " << endl;      //*
            r << "</title>" << endl;                                                //*
        r << "</head>" << endl;                                                     ///header
        r << "<body>" << endl;                                                      //body
             r << "<table"  << endl;
                r << "<tr>";
                for(size_t i = 0; i < spalten.size(); i++){
		  r << "<th>" << titel[i] << "</th>";
                }
                r << "</tr>" << endl;
                for(size_t i = 0; i < spalten[0].werte.size(); i++){
                    r << "<tr>";
                    std::cout << "I" << i << endl;
                    for(size_t j = 0; j < spalten.size(); j++){
                        r << "<td align=\"right\">";
                        std::cout << "J" << j << endl;
                        switch(spalten[j].type){
                            case StringSpalte:
                                r << spalten[j].werte[reihenfolge[i]].stw;
                                break;
                            case IntSpalte:
                                r << spalten[j].werte[reihenfolge[i]].iw;
                                break;
                            case DoubleSpalte:
                                r << spalten[j].werte[reihenfolge[i]].dw;
                                break;
                            default:
                                std::cout << "Error im Werte-System!" << endl;
                                break;
                        }
                        r << "</td>";
                    }
                    r << "</tr>" << endl;
                }
             r << "</table>" << endl;
        r << "</body>" << endl;
    r << "</html";
    r.close();
} 

void MenueSystem::setloc() { 
    
    locale loc;                                     // Lokale setzen (fkt leider nur fuer double, int64_t ist unberuehrt)
    if (waehrung == EUR) {
        loc.global(locale("de_DE.utf8"));
    }
    else {
        loc.global(locale("en_US.utf8"));
    }
    cout.imbue(loc);
    
}

void MenueSystem::setWaehrung() { 
    switch(waehrung) {
        case EUR: 
        {
            waehrung = USD;
            break;
            
        }
        case USD: 
        {
            waehrung = EUR;
            break;
        }
    }
    setloc();
}